/***************************************************************************
                          extended_browser.h  -  description
                             -------------------
    begin                : Wed Jul 16 2003
    copyright            : (C) 2003 by George Goh
    email                : georgegohkokleong@hotmail.com
 ***************************************************************************/

#ifndef EXTENDED_BROWSER_H
#define EXTENDED_BROWSER_H

#include <vector>
#include <string>
#define MWINCLUDECOLORS
#include <microwin/nano-X.h>
#include "formstruct.h"
#include <cstdio>

using namespace std;
/**
  *@author George Goh
  */
namespace GUI {
  
class Extended_Browser {
private:
  GR_REGION_ID clipRegion;
  bool drawnOnce;
  int position;
public:
  int x,y,w,h;
  unsigned int size, line_h;
  vector<string> optionTips;
  vector<string> items;
  GR_FONT_ID fontId;
  vector<formText> items_onscreen;
  
  Extended_Browser(int _x,int _y,int _w,int _h,vector<string> &inList,
                                   vector<string> &listTips, int _fontSize);

	~Extended_Browser();

  void setOptionList(vector<string> &inList) {
    vector<string> emptyStrings;
    setOptionList(inList, emptyStrings);
  }
  void setOptionList(vector<string> &inList, vector<string> &listTips);

  const vector<string> getOptionTips() const { return optionTips; }
  //int handle(int event);
  void value(int);
  int value();
  void resolveItemDimensions();
  void draw();
  int handle(GR_EVENT* event);
  void refresh() {
    printf("extended_browser refresh\n");
    drawnOnce=false;
    for(unsigned int i=1; i<=size; ++i) items_onscreen[i].damage=true;
  }
};

}

#endif
